--[[
--------------------------------------------------------------------------------------
----  PLCSCRIPT  PLCSCRIPT  PLCSCRIPT  PLCSCRIPT  PLCSCRIPT  PLCSCRIPT  PLCSCRIPT ----
--------------------------------------------------------------------------------------
--if ServoLinkRS422 == 0 then OpenPortRS422() end
--------------------------------------------------------------------------------------
----  UNLOAD SCRIPT  UNLOAD SCRIPT  UNLOAD SCRIPT  UNLOAD SCRIPT  UNLOAD SCRIPT   ----
--------------------------------------------------------------------------------------
--if ServoLinkRS422 ==1 then ClosePortRS422() end
--------------------------------------------------------------------------------------
----   SCREEN SCRIPT  SCREEN SCRIPT  SCREEN SCRIPT  SCREEN SCRIPT  SCREEN SCRIPT  ----
--------------------------------------------------------------------------------------
--DrivesComRS422 module
package.loaded.DrivesComRS422 = nil
DrivesComRS422 = require "DrivesComRS422"
--------------------------------------------------------------------------------------
---- PLC SCRIPT   PLC SCRIPT   PLC SCRIPT   PLC SCRIPT   PLC SCRIPT   PLC SCRIPT  ----
--------------------------------------------------------------------------------------
if machEnabled == 0 then			                            --Mach Disabled	behavoir
	SyncEnableCycle = 0                                         --Reset Enablecycle 
end
if machEnabled == 1 and SyncEnableCycle == 0 then  				--Mach Enabled	behavoir
	wx.wxMilliSleep(1000)										--await 1s
			if Servo_Ready == 1 then									--Check servo Ready signals
			mc.mcAxisHomeAll(inst)                              		--Reference all axes inplace to set to 0 coordinates
			ABS_Sync()												--Update ABS Position
			SyncEnableCycle = 1
	end
end
]]
------------------------------------Start of Code DrivesCom RS422-----------------------------------
package.path = package.path .. ";./Modules/?.lua;"
package.cpath = package.cpath .. ";./Modules/?.dll;"
--package.cpath = "C:/src/Mach4/Modules/?.dll;"
rs422 = require("luars232")
socket = require("socket")
--------------------------------------Variable Declaration Section----------------------------------
ServoLinkRS422 = 0
Sync = 0
GetPosReady = 0
SyncEnableCycle = 0
local inst = mc.mcGetInstance()
local port_name = "COM4"	--Serial RS422 Ultracomm
local DataRead = ""
local Checksum = ""
local ChecksumCode = ""
local Verification = ""
local Data = ""
local YOffset = 0
ServoABSPos = {[0] = Drive0POS, [1] = Drive1POS, [2] = Drive2POS, [3] = Drive3POS, [4] = Drive4POS}
local out = io.stderr
-----------------------------------------------Open Com Port------------------------------------------------
function OpenPortRS422()
	p, Drives = rs422.open(port_name)
	if p ~= rs422.RS232_ERR_NOERROR then
	-- handle error
	mc.mcCntlSetLastError(inst,string.format("can't open serial port '%s', error: '%s'\n",port_name, rs422.error_tostring(p)))
	return
end
----------------------------------------------set port settings---------------------------------------------
assert(Drives:set_baud_rate(rs422.RS232_BAUD_115200) == rs422.RS232_ERR_NOERROR)
assert(Drives:set_data_bits(rs422.RS232_DATA_8) == rs422.RS232_ERR_NOERROR)
assert(Drives:set_parity(rs422.RS232_PARITY_EVEN) == rs422.RS232_ERR_NOERROR)
assert(Drives:set_stop_bits(rs422.RS232_STOP_1) == rs422.RS232_ERR_NOERROR)
assert(Drives:set_flow_control(rs422.RS232_FLOW_OFF)  == rs422.RS232_ERR_NOERROR)
--mc.mcCntlSetLastError(inst,string.format("OK, port open with values '%s'\n", tostring(Drives)))
ServoLinkRS422 = 1
end
--------------------------------------------------Close Com Port---------------------------------------------
function ClosePortRS422()
assert(Drives:close() == rs422.RS232_ERR_NOERROR)
ServoLinkRS422 = 0          --Port RS422 Closed
end
-------------------------------------------------Write to Serial Port----------------------------------------
function DrivesComSend(SendData)
	local timeout = 10							-- in miliseconds
	local err, len_written = Drives:write(SendData, timeout)
	assert(p == rs422.RS232_ERR_NOERROR)
	--mc.mcCntlSetLastError(inst,"RS422 Send: "..SendData)
end
----------------------------------------------------Read Serial Port------------------------------------------
function DrivesComRead()
	local read_len = 22						--max read 22 bytes
	local timeout = 50  							-- in miliseconds
	err, DataRead, size = Drives:read(read_len, timeout)
	assert(p == rs422.RS232_ERR_NOERROR)
------------------------------------------------ASCII to Hex Converter----------------------------------------
	if DataRead ~= nil then
    ChecksumVerify(DataRead)
	--mc.mcCntlSetLastError(inst,"RS422 Read: "..DataRead)
	return DataRead
	else 
		mc.mcCntlSetLastError(inst,"RS422 No Response")
		end
end
-------------------------------------------------------Flush buffer-------------------------------------------
--Windows automatically fills a serial buffer with characters (up to 4096 I think)
--This function reads the entire buffer to empty it out
function DrivesComFlushBuffer()
	Drives:flush()
end
-------------------------------------------Decompose Frame to Extract Data---------------------------------------------
function FrameRead(Data)
	local Data1 = ""
	if string.byte(Data:sub(1)) == 1 or string.byte(Data:sub(1)) == 2 then Data1 = Data:sub(2,string.len(Data)) end
	StrData = ""
	Station = Data1:sub(1,1)
	ErrorCode = Data1:sub(2,2)
	StrData = tonumber(Data1:sub(3,(string.len(Data1))-3),16)
	ChecksumCode = Data1:sub(-2) --2 lsb
	--mc.mcCntlSetLastError(inst,"\nStation No: "..Station.."\nError Code: "..ErrorCode.."\nDataRead: "..StrData.."\nChecksumCode: "..ChecksumCode)
end
-------------------------------------------------Checksum calculation--------------------------------------------------
function ChecksumCalculate(Data)
local DecSum = 0
local DEC = ""
	if string.byte(Data:sub(1)) == 1 or string.byte(Data:sub(1)) == 2 then Data = Data:sub(2,string.len(Data)) end
  for i=1,(string.len(Data)),1 do DEC = string.byte(Data,i)
    if DEC ~= nil then DecSum = DecSum + DEC end
    --mc.mcCntlSetLastError(inst,"DEC: "..DEC.." Sum: "..DecSum)
    if string.byte(Data,i+1) == 3 then DecSum = DecSum + 3
      checksum = (string.format("%x", DecSum)):sub(-2) --2 lsb
	  --mc.mcCntlSetLastError(inst,"\nCalculated Checksum:",checksum)
	break end
  end
end
--------------------------------------------Drives Communication function----------------------------------------------
function Comm_Drives(Msg)								 --Start communication with drives
---------------------------------Await for driver response--------------------------------
    local Read = nil  
	  for retry = 1,3,1 do                        --3 times retransmision if no response
        DrivesComSend(""..Msg)								  --Serial transmit
        --mc.mcCntlSetLastError(inst,"\nPort sending Data: ",""..Msg)
        Read = DrivesComRead()											      --Serial Read
        if Read ~= "" then	                    --Check response have data
        --mc.mcCntlSetLastError(inst,"Data Read ~= nil")
        break end   	                              --exit loop Await response
        wx.wxMilliSleep(300)										  --await 300ms
        DrivesComSend("")										  --sent End Of Transmission
        --mc.mcCntlSetLastError(inst,"\nPort sending Data: ","")
        wx.wxMilliSleep(100)                      --await 300ms
      end
      ---------------------------------driver no response--------------------------------
       if Read == "" then										--If response have no data
        FrameRead(""..Msg)										    --FrameRead decompose Frame
        mc.mcCntlSetLastError(inst,"Drive Not Responding")
        return end
  -------------------------Check Checksum Response if data ~= nil--------------------------
    for	resend = 1,3,1 do								                      --3 times retransmision if Error Code
        if ErrorCode == "A" or ErrorCode == "a" and Verification == 1--Check for error codes/checksum
        then break
        else                                         --exit loop retransmision if no Error 
          DrivesComSend(""..Msg)								              --Serial transmit
          --mc.mcCntlSetLastError(inst,"\nPort Sending Data: ",""..Msg)
          DrivesComRead()											                  --Serial Read
          if Verification == 0 then                             --Detect Checksum Error 
          mc.mcCntlSetLastError(inst,"Drive "..Station.."Response Checksum Error") end--Show error
          if ErrorCode ~= "A" then 
          ErrorProcess(Station,ErrorCode)                       --Process error code
          end
        end
    end
end
---------------------------------------------------Append Checksum-----------------------------------------------------
function ChecksumAppend(Data)
  ChecksumCalculate(Data)
  Data = Data..checksum
  --mc.mcCntlSetLastError(inst,"\nSendData:",Data)
end
----------------------------------------------------Verify Checksum----------------------------------------------------
function ChecksumVerify(Data)
  ChecksumCalculate(Data)
  FrameRead(Data)
  if(tonumber(checksum,16) == tonumber(ChecksumCode,16))then 
  Verification = 1 
  else verification = 0 
  --mc.mcCntlSetLastError(inst,"Calculated: "..checksum.."ChecksumCode: "..ChecksumCode.."Verification: "..string.format(Verification))
end
end
-------------------------------------------------------Get ABS Position------------------------------------------------
function ABSGetPosition()
--mc.mcCntlSetLastError(inst,"ABS GET POSITION CALL")
GetPosReady = 0
local Counts = 0  
	ServoABSPos = {[0] = Drive0POS, [1] = Drive1POS, [2] = Drive2POS, [3] = Drive3POS, [4] = Drive4POS}
	for Servo=0,4,1 do
    Data = Servo.."0291"
    ChecksumCalculate(Data)
    Data = Data..checksum
    Comm_Drives(Data)                           --Call to communition fuction
        if ErrorCode == "A" and Verification == 1  then
        if StrData > 700000 then
			Counts = -4294967296 + StrData
			ServoABSPos[Servo] = Counts * 0.001	--1/0.001 = 1000 pulses since command unit is um -- Save ABS Position to Array
		else
			Counts = StrData
			ServoABSPos[Servo] = Counts * 0.001	--1/0.001 = 1000 pulses since command unit is um -- Save ABS Position to Array
		end
		mc.mcCntlSetLastError(inst,"\nMotor "..Servo.." Counts: "..Counts.."Position: "..ServoABSPos[Servo].."mm")--Print Data Received
      GetPosReady = 1
      else
        GetPosReady = 0
        ErrorProcess(Servo,ErrorCode) 										                      --Show communication error
        break
      end
	end
end
--------------------------------------------SERVO LOCK REQUEST---------------------------------------------
function Servolock()
  for Servo=0,4,1 do
    Data = Servo.."90001EA5"
    ChecksumCalculate(Data)
    Data = Data..checksum
    ChecksumVerify(Data)
    Comm_Drives(Data)                           --Call to communition fuction
      if ErrorCode == "A" and Verification == 1  then
      --mc.mcCntlSetLastError(inst,"\nMotor "..Servo.." Locked")								--Print Data Received
      else mc.mcCntlSetLastError(inst,"Failure to lock drive "..Servo)
      end
    end
  end
  -------------------------------------------SERVO UNLOCK REQUEST--------------------------------------------
function ServoUnlock()
  for Servo=0,4,1 do
    Data = Servo.."90101EA5"
    ChecksumCalculate(Data)
    Data = Data..checksum
    Comm_Drives(Data)                           --Call to communition fuction
      if ErrorCode == "A" and Verification == 1  then
      --mc.mcCntlSetLastError(inst,"\nMotor "..Servo.." Unlocked")								--Print Data Received
      else mc.mcCntlSetLastError(inst,"Failure to unlock drive "..Servo)
      end
    end
  end
-------------------------------------------SERVO RESET REQUEST--------------------------------------------  
function ServoReset()
  for Servo=0,4,1 do
    Data = Servo.."82001EA5"
    ChecksumCalculate(Data)
    Data = Data..checksum
    ChecksumVerify(Data)
    Comm_Drives(Data)                           --Call to communition fuction
      if ErrorCode == "A" and Verification == 1  then
      --mc.mcCntlSetLastError(inst,"\nMotor "..Servo.." Locked")								--Print Data Received
      else mc.mcCntlSetLastError(inst,"Failure to reset drive "..Servo)
      end
    end
  end  
------------------------------------------GANTRY Y2 MOTOR SQUARE-------------------------------------------
--Update motor positions to servo positions/square the Y2 gantry
function AxisAlign()
	YAligned = 0
	local  YCorrect = -ServoABSPos[1] + YOffset
			local hLimits = mc.mcSignalGetHandle(inst, mc.OSIG_OUTPUT6)
			mc.mcSignalSetState(hLimits, 0) 							--Forward/Reverse Rotation Disable
	wx.wxMilliSleep(200)									    	--await plc relay
	mc.mcAxisUnmapMotor(inst, 1, 3)									--Description: Unmap the motor 3(Y2) from the axis 1(Y)(inst, axisId, motorId)
	--wx.wxMilliSleep(100)
	mc.mcAxisMapMotor(inst, 5, 3)									--Description: Map motor 3 to axis 5(C)
	Axis_Enable()
		--wx.wxMilliSleep(100)
		mc.mcCntlGcodeExecuteWait(inst, "G53 G00 X" .. ServoABSPos[0])	-- Update axis X dro to position of motor 0
		mc.mcCntlGcodeExecuteWait(inst, "G53 G00 Y" .. -ServoABSPos[1])	-- Update axis Y dro to position of motor 1
		mc.mcCntlGcodeExecuteWait(inst, "G53 G00 Z" .. ServoABSPos[2])	-- Update axis Z dro to position of motor 2
		mc.mcCntlGcodeExecuteWait(inst, "G53 G00 B" .. ServoABSPos[4])	-- Update axis B dro to position of motor 4
		mc.mcCntlGcodeExecuteWait(inst, "G53 G00 C" .. -ServoABSPos[3])-- Update axis C dro to position of motor 3
			local hLimits = mc.mcSignalGetHandle(inst, mc.OSIG_OUTPUT6)
			mc.mcSignalSetState(hLimits, 1) 							--Forward/Reverse Rotation Enable
	wx.wxMilliSleep(200)										   		--await plc relay
	local Error = (ServoABSPos[1] - ServoABSPos[3]) + YOffset
	if Error < 1 and Error > -1 then
		mc.mcCntlGcodeExecuteWait(inst, "G53 G00 C" .. YCorrect)		-- Move motor 3 mapped to axis 5(C) to Y corrected position
		YAligned = 1
	else
		mc.mcCntlSetLastError(inst,"Exessive position error Y2\n".."Y ABS: "..ServoABSPos[1].."\n".."Y2 ABS: "..ServoABSPos[3])
	end
		mc.mcAxisUnmapMotor(inst, 5, 3)--Description: Unmap the motor 3 from the axis 5(C)
		mc.mcAxisMapMotor(inst, 1, 3)--Description: Map motor 3 to an axis 1(Y2)
		Axis_Enable()
end
-------------------------------------------------------Enable Limits---------------------------------------------------------
function SetSoftlimitsOn()
    for v = 0, 5, 1 do -- start, end, incement
       mc.mcSoftLimitSetState(inst, v, mc.MC_ON)
	   
    end
end
------------------------------------------------------Disable Limits---------------------------------------------------------
function SetSoftlimitsOff()
    for v = 0, 5, 1 do -- start, end, incement
       mc.mcSoftLimitSetState(inst, v, mc.MC_OFF)
	   
    end
end
function Axis_Enable()
    for v = 0, 5, 1 do -- start, end, incement
       mc.mcAxisEnable(inst, v, 1)
	   
    end
end
-------------------------------Syncronize ABS Position/Align Y axis/Enable Mach------------------------------------
function ABS_Sync()
	--Syncronize ABS Position/Align Y axis/Enable Mach
	--Get positions before Sync Position
 local valX, rc = mc.mcAxisGetMachinePos(inst, mc.X_AXIS) --Get the position of the X axis in Machine Position
 local valY, rc = mc.mcAxisGetMachinePos(inst, mc.Y_AXIS) --Get the position of the Y axis in Machine Position
 local valZ, rc = mc.mcAxisGetMachinePos(inst, mc.Z_AXIS) --Get the position of the Z axis in Machine Position
 local valB, rc = mc.mcAxisGetMachinePos(inst, mc.B_AXIS) --Get the position of the A axis in Machine Position 
local posmode = mc.mcCntlGetPoundVar(inst, mc.SV_MOD_GROUP_3) 	--get the current mode so we can return to it when code ends
ABSGetPosition()            									--Update ABS Position
wx.wxMilliSleep(100)										    --await 100ms	
	if GetPosReady == 1 then        							--ABS pos syncronized
		--mc.mcAxisHomeAll(inst)                              	--Reference all axes inplace to set to 0 coordinates
		SetSoftlimitsOff()
		AxisAlign() 											-- Move Axis to Servo position
		SetSoftlimitsOn()
		if YAligned == 1 then
			mc.mcCntlGcodeExecuteWait(inst, "G90 G53 G0 Z" .. tonumber(valZ) .. "X" .. tonumber(valX) .. "Y" .. tonumber(valY) .. "B" .. tonumber(valB)) --Move back to X & Y initial location
			mc.mcCntlSetLastError(inst,"Servo Position Syncronized")
			Synchronized = 1
		else
			mc.box("Can't Sychronize Servo Position\n")
		end
	else
		mc.mcCntlSetLastError(inst,"Servo Position Get Failure")
	end
	mc.mcCntlGcodeExecute(inst, string.format('G ' .. posmode))		--return to pre macro mode G90, or G91
end
------------------------------------------GANTRY Y2 MOTOR SQUARE-------------------------------------------
--[[Update motor positions to servo positions/square the Y2 gantry
function AxisAlign()
	YAligned = 0
	local  YCorrect = -ServoABSPos[1] + YOffset
	if (-ServoABSPos[1] - YCorrect) < 1 then
		mc.mcMotorSetHomePos(inst, 0, tonumber(ServoABSPos[0]))
		mc.mcMotorSetHomePos(inst, 0, -tonumber(ServoABSPos[1]))
		mc.mcMotorSetHomePos(inst, 0, tonumber(ServoABSPos[2]))
		mc.mcMotorSetHomePos(inst, 0, -tonumber(ServoABSPos[3]))
		mc.mcMotorSetHomePos(inst, 0, tonumber(ServoABSPos[4]))
		mc.mcAxisHomeAll(inst)
		mc.mcAxisUnmapMotor(inst, 1, 3)--Description: Unmap the motor 3(Y2) from the axis 1(Y)(inst, axisId, motorId)
		mc.mcAxisMapMotor(inst, 5, 3)--Description: Map motor 3 to axis 5(C)
		mc.mcCntlGcodeExecute(inst, "G53 G01 C" .. tonumber(YCorrect) ..  "f100")-- Move motor 3 mapped to axis 5(C) to Y corrected position
		mc.mcAxisUnmapMotor(inst, 5, 3)--Description: Unmap the motor 3 from the axis 5(C)
		mc.mcAxisMapMotor(inst, 1, 3)--Description: Map a motor 3 to an axis 1(Y2)
		YAligned = 1
	else
		mc.mcCntlSetLastError(inst,"Exessive position error Y2\n".."Y ABS: "..ServoABSPos[1].."\n".."Y2 ABS: "..ServoABSPos[3])
	end
end
]]
-------------------------------------------------------Get Current Alarm--------------------------------------------
function GetCurrentAlarm()		--Get Current Alarm
  Servo={0,1,2,3,4}
	for Servo=0,4,1 do
	Data = Servo.."0200"
	ChecksumCalculate(Data)
	Data = Data..checksum
	Comm_Drives(Data)
		if string.format("%04x",StrData) == "00ff" then break else
		mc.mcCntlSetLastError(inst,"Motor: "..Servo.." Alarm Code: "..StrData)								--Print Data Received
		end
	end
end
---------------------------------------------Error Processing----------------------------------------
function ErrorProcess(Drive,ErrorCode)
		if ErrorCode == "a" then mc.mcCntlSetLastError(inst, "Drive ", Drive ,string.format("Alarm"))
	elseif ErrorCode == "B" or ErrorCode == "b" then mc.mcCntlSetLastError(inst, "Drive "..Drive.string.format("Parity error"))
	elseif ErrorCode == "C" or ErrorCode == "c" then mc.mcCntlSetLastError(inst, "Drive "..Drive..string.format("Checksum error"))
	elseif ErrorCode == "D" or ErrorCode == "d" then mc.mcCntlSetLastError(inst, "Drive "..Drive..string.format("Character error"))
	elseif ErrorCode == "E" or ErrorCode == "e" then mc.mcCntlSetLastError(inst, "Drive "..Drive..string.format("Command error"))	
	elseif ErrorCode == "F" or ErrorCode == "f" then mc.mcCntlSetLastError(inst, "Drive "..Drive..string.format("Data No. error"))
	elseif ErrorCode == ""  then mc.mcCntlSetLastError(inst, "Drive "..Drive.." Communication Error")
	end
end